Index: CMT/HEAD/source/cmt_use.cxx
===================================================================
--- CMT/HEAD/source/cmt_use.cxx	(revision 586)
+++ CMT/HEAD/source/cmt_use.cxx	(revision 588)
@@ -1624,4 +1624,5 @@
   // On deplace tous les pointeurs d'une case en arriere
   //
+  //cerr << "move-0> " << use->get_package_name () << "[" << use->m_index << "]" << endl;
   for (use_index++; use_index < size; use_index++)
     {
@@ -1629,4 +1630,5 @@
       u->m_index--;
 
+      //cerr << "move-1> " << u->get_package_name () << "[" << u->m_index << "]" << endl;
       uses[use_index - 1] = uses[use_index];
     }
@@ -1638,4 +1640,5 @@
   use->m_index = size - 1;
   uses[size - 1] = use;
+  //cerr << "move-2> " << use->get_package_name () << "[" << use->m_index << "]" << endl;
 }
 
@@ -3815,7 +3818,11 @@
 
       if (CmtMessage::active (Info))
-	cerr << "   Creating the reference file " << ref_file << endl;
+	cerr << "   Creating reference file " << ref_file << endl;
 	  //      if (!Cmt::get_quiet ()) cerr << "   Creating the reference file " << ref_file << endl;
-      text.write (ref_file);
+      if (!text.write (ref_file))
+	{
+	  CmtError::set (CmtError::file_access_error, ref_file);
+	  return false;
+	}
     }
   else
@@ -3844,5 +3851,8 @@
   if (same_dirs (source, dest))
     {
-      return (false);
+      cmt_string lname;
+      CmtSystem::basename (libname, lname);
+      if (lname == name)
+	return true;
     }
 
@@ -3855,5 +3865,6 @@
       if (!CmtSystem::create_symlink (libname, s))
 	{
-	  CmtMessage::error ("Cannot create a symbolic link to " + libname);
+	  CmtError::set (CmtError::file_access_error, "Cannot create symbolic link to " + libname);
+	  //CmtMessage::error ("Cannot create a symbolic link to " + libname);
 	  //	  cerr << "#CMT> Cannot create a symbolic link to " << libname << endl;
 	  return (false);
@@ -3867,10 +3878,9 @@
       cmd += " ";
       cmd += s;
-      
       int status = CmtSystem::execute (cmd);
-      
       if (status != 0)
 	{
-	  CmtMessage::error ("Cannot create a symbolic link to " + libname);
+	  CmtError::set (CmtError::execution_error, "Cannot create symbolic link to " + libname);
+	  //CmtMessage::error ("Cannot create a symbolic link to " + libname);
 	  //	  cerr << "#CMT> Cannot create a symbolic link to " << libname << endl;
 	  return (false);
@@ -3881,8 +3891,188 @@
 }
 
-
+//----------------------------------------------------------
+static bool uninstall_library (const cmt_string& source_library_name, 
+			       const cmt_string& dest_library_name, 
+			       const cmt_string& cmtinstallarea, 
+			       const cmt_string& tag, 
+			       const cmt_string& symunlinkcmd)
+{
+  cmt_string libname = source_library_name;
+  cmt_string name = dest_library_name;
+  cmt_string s;
+  Use& current_use = Use::current ();
+
+  Symbol::expand (name);
+  Symbol::expand (libname);
+
+  if (cmtinstallarea != "")
+    {
+      s = cmtinstallarea;
+      s += CmtSystem::file_separator ();
+      s += tag;
+      s += CmtSystem::file_separator ();
+      s += "lib";
+      s += CmtSystem::file_separator ();
+      s += name;
+      
+      // Now removing the reference file
+
+      cmt_string r = s;
+      r += ".cmtref";
+
+      if (CmtMessage::active (Info))
+	cerr << "   Removing reference file " << r << endl;
+      if (symunlinkcmd == "")
+	{
+	  if (!CmtSystem::remove_file (r) && CmtSystem::test_file(r))
+	    {
+	      CmtError::set (CmtError::file_access_error, r);
+	      return false;
+	    }
+	}
+      else
+	{
+	  cmt_string cmd (symunlinkcmd);
+	  cmd += " ";
+	  cmd += r;
+	  int status = CmtSystem::execute (cmd);
+	  if (status != 0)
+	    {
+	      //                  if (status != 2) CmtError::set (CmtError::execution_error, s);
+	      CmtError::set (CmtError::execution_error, cmd);
+	    }
+	}
+    }
+  else
+    {
+      if (current_use.style != none_style)
+	{
+	  s = "../$(";
+	  s += current_use.get_package_name ();
+	  s += "_tag)/";
+	}
+      else
+	{
+	  s = "./";
+	}
+      s += name;
+    }
+
+  Symbol::expand (s);
+
+  cmt_string source;
+  cmt_string dest;
+
+  CmtSystem::dirname (libname, source);
+  CmtSystem::dirname (s, dest);
+
+  if (same_dirs (source, dest))
+    {
+      cmt_string lname;
+      CmtSystem::basename (libname, lname);
+      if (lname == name)
+	return true;
+    }
+
+  //if (!Cmt::get_quiet ()) 
+  if (CmtMessage::active (Info))
+    cerr << "   Removing symlink " << s << " to " << libname << endl;
+
+  if (symunlinkcmd == "")
+    {
+      if (!CmtSystem::remove_file (s) && CmtSystem::test_file(s))
+	{
+	  CmtError::set (CmtError::file_access_error, "Cannot remove symbolic link to " + libname);
+	  return (false);
+	}
+    }
+  else
+    {
+      cmt_string cmd = symunlinkcmd;
+      cmd += " ";
+      cmd += s;
+      int status = CmtSystem::execute (cmd);
+      if (status != 0)
+	{
+	  CmtError::set (CmtError::execution_error, "Cannot remove symbolic link to " + libname);
+	  //CmtMessage::error ("Cannot create a symbolic link to " + libname);
+	  //	  cerr << "#CMT> Cannot create a symbolic link to " << libname << endl;
+	  return (false);
+	}
+    }
+  
+  return (true);
+}
+
+//----------------------------------------------------------
 /**
-   Centralize the construction of library links for this Use.
-*/
+ *  This function construct absolute library path
+ *  for libraries specified via <package>_libraries macros
+ *  to be used by build[remove]_library_links functions,
+ *  and class Generator build_library_links_infile function, in particular.
+ */
+void Use::absolute_library_path (const cmt_string& libname,
+				 const cmt_string& shlibsuffix, 
+				 CmtSystem::cmt_string_vector& paths) const
+{
+  if (CmtSystem::absolute_path (libname))
+    {
+      paths.push_back (libname);
+      return;
+    }
+
+  /**
+   *   Here we expect that only the base name of the library
+   *   is given : ie it should not contain the "lib" prefix, 
+   *   nor the suffix .so, nor any path prefix.
+   *   This of course should generally correspond to a constituent name.
+   */
+  cmt_string libpath;
+  if (style != none_style)
+    {
+      libpath = "${";
+      libpath += prefix;
+      libpath += "ROOT}/${";
+      libpath += get_package_name ();
+      libpath += "_tag}/";
+    }
+  else
+    {
+      libpath = "${";
+      libpath += prefix;
+      libpath += "ROOT}/";
+    }
+  libpath += "$(library_prefix)";
+  libpath += libname;
+  libpath += "$(library_suffix)";
+  libpath += ".";
+  libpath += shlibsuffix;
+  paths.push_back (libpath);
+
+#ifdef __APPLE__
+  if (style != none_style)
+    {
+      libpath = "${";
+      libpath += prefix;
+      libpath += "ROOT}/${";
+      libpath += get_package_name ();
+      libpath += "_tag}/";
+    }
+  else
+    {
+      libpath = "${";
+      libpath += prefix;
+      libpath += "ROOT}/";
+    }
+  libpath += libname;
+  libpath += ".bundle";
+  paths.push_back (libpath);
+#endif
+}
+
+//----------------------------------------------------------
+/**
+ *   Centralize the construction of library links for this Use.
+ */
 void Use::build_library_links (const cmt_string& cmtinstallarea, 
 			       const cmt_string& tag, 
@@ -3933,89 +4123,79 @@
       libname = library;
       Symbol::expand (libname);
-
-      bool is_absolute = false;
-
-      is_absolute = CmtSystem::absolute_path (libname);
-
-      if (is_absolute)
-	{
-	  /**
-	   *   We assume here that "library" contains a complete path.
-	   *   (including the complete syntax libxxx.so)
-	   */
-
-	  cmt_string suffix;
-	  CmtSystem::basename (library, name);
-	}
-      else
-	{
-	  /**
-	   *   Here we expect that only the base name of the library
-	   *   is given : ie it should not contain the "lib" prefix, 
-	   *   nor the suffix .so, nor any path prefix.
-	   *    This of course should generally correspond to a constituent name.
-	   */
-	  
-	  if (style != none_style)
-	    {
-	  libname = "${";
-	  libname += prefix;
-	  libname += "ROOT}/${";
-	  libname += get_package_name ();
-	  libname += "_tag}/";
-	    }
-	  else
-	    {
-	  libname = "${";
-	  libname += prefix;
-	  libname += "ROOT}/";
-	    }
-	  libname += "$(library_prefix)";
-	  libname += library;
-	  libname += "$(library_suffix)";
-	  libname += ".";
-	  libname += shlibsuffix;
-
-	  name = "$(library_prefix)";
-	  name += library;
-	  name += "$(library_suffix)";
-	  name += ".";
-	  name += shlibsuffix;
-	}
-
-      if (!install_library (libname, name, cmtinstallarea, tag, symlinkcmd))
-	{
-	  continue;
-	}
-
-#ifdef __APPLE__
-      if (!is_absolute)
-	{
-	  if (style != none_style)
-	    {
-	  libname = "${";
-	  libname += prefix;
-	  libname += "ROOT}/${";
-	  libname += get_package_name ();
-	  libname += "_tag}/";
-	    }
-	  else
-	    {
-	  libname = "${";
-	  libname += prefix;
-	  libname += "ROOT}/";
-	    }
-	  libname += library;
-	  libname += ".bundle";
-
-	  name = library;
-	  name += ".bundle";
-	  
-	  if (!install_library (libname, name, cmtinstallarea, tag, symlinkcmd))
-	    {
-	      continue;
-	    }
-	}
-#endif
+      if (0 == libname.size ()) continue;
+
+      CmtSystem::cmt_string_vector paths;
+      absolute_library_path (libname,
+			     shlibsuffix, 
+			     paths);
+
+      for (int k = 0; k < paths.size (); k++)
+	{
+	  CmtSystem::basename (paths[k], name);
+	  if (!install_library (paths[k], name, cmtinstallarea, tag, symlinkcmd))
+	    {
+	      CmtError::print ();
+	    }
+	}
+    }
+}
+//----------------------------------------------------------
+/**
+ *   Centralize the removal of library links for this Use.
+ */
+void Use::remove_library_links (const cmt_string& cmtinstallarea, 
+				const cmt_string& tag, 
+				const cmt_string& shlibsuffix, 
+				const cmt_string& symunlinkcmd) const
+{
+  if (!located ())
+    {
+      CmtMessage::warning ("package " + get_package_name ()
+			   + " " + version + " " + path
+			   + " not found");
+      return;
+    }
+
+  cmt_string s;
+
+  s = get_package_name ();
+  s += "_libraries";
+
+  Symbol* libraries_macro = Symbol::find (s);
+
+  if (libraries_macro == 0) return;
+
+  cmt_string libraries = libraries_macro->build_macro_value ();
+  Symbol::expand (libraries);
+  static CmtSystem::cmt_string_vector values;
+
+  CmtSystem::split (libraries, " \t", values);
+
+  for (int j = 0; j < values.size (); j++)
+    {
+      const cmt_string& library = values[j];
+
+      static cmt_string libname;
+      static cmt_string name;
+
+      // Is it a simple name or a complete path?
+
+      libname = library;
+      Symbol::expand (libname);
+      if (0 == libname.size ()) continue;
+
+      CmtSystem::cmt_string_vector paths;
+      absolute_library_path (libname,
+			     shlibsuffix, 
+			     paths);
+      
+      for (int k = 0; k < paths.size (); k++)
+	{
+	  CmtSystem::basename (paths[k], name);
+	  if (!uninstall_library (paths[k], name, cmtinstallarea, tag, symunlinkcmd))
+	    {
+	      CmtError::print ();
+	    }
+	}
     }
 }
Index: CMT/HEAD/source/cmt_use.h
===================================================================
--- CMT/HEAD/source/cmt_use.h	(revision 586)
+++ CMT/HEAD/source/cmt_use.h	(revision 588)
@@ -118,5 +118,9 @@
 			    const cmt_string& shlibsuffix, 
 			    const cmt_string& symlinkcmd) const;
-
+  void remove_library_links (const cmt_string& cmtinstallarea, 
+			     const cmt_string& tag, 
+			     const cmt_string& shlibsuffix, 
+			     const cmt_string& symunlinkcmd) const;
+  
   bool get_all_clients (const cmt_string& to_name);
 
@@ -152,4 +156,7 @@
   bool is_head_version (const cmt_string& version);
   void clear ();
+  void absolute_library_path (const cmt_string& libname,
+			      const cmt_string& shlibsuffix, 
+			      CmtSystem::cmt_string_vector& paths) const;
 // Public attributes
 public:
Index: CMT/HEAD/src/Makefile.core
===================================================================
--- CMT/HEAD/src/Makefile.core	(revision 586)
+++ CMT/HEAD/src/Makefile.core	(revision 588)
@@ -135,3 +135,3 @@
 # add to the list of valid suffixes
 # so that nonterminal match-anything rules will not be considered
-.SUFFIXES: .make .stamp .cxx
+.SUFFIXES: .make .in .stamp .cxx
Index: CMT/HEAD/src/Makefile.header
===================================================================
--- CMT/HEAD/src/Makefile.header	(revision 586)
+++ CMT/HEAD/src/Makefile.header	(revision 588)
@@ -19,81 +19,89 @@
 
 cmt_local_tagfile = $(bin)$(tag).make
+cmt_broadcast_tagfile = $(bin)$(tag)_broadcast.make
 
 cmt_constituents_makefile = $(bin)constituents.make
-
-cmt_local_setup = $(bin)setup$$$$.make
-#cmt_local_setup = $(bin)$(package)setup$$$$.make
-#cmt_final_setup = $(bin)${PACKAGE}setup.make
+cmt_broadcast_makefile = $(bin)broadcast.make
+
 cmt_final_setup = $(bin)setup.make
-#cmt_final_setup = $(bin)$(package)setup.make
-
-#
-#  Generic entry points for all targets
-#
-#ifndef QUICK
-#all :: check_config ;
-#else
-#all :: no_check_config ;
-#endif
-#all :: $(cmt_constituents_makefile)
-#	@$(MAKE) --no-print-directory -f $(cmt_constituents_makefile) $@
-default :: all ;
+
+cmt_check_configurationstamp = $(bin)cmt_check_configuration.stamp
+
+ifdef CMTBCAST
+QUICK = 1
+endif
+
+ifdef QUICK
+ifndef CMTBCAST
+
+ifneq ($(MAKECMDGOALS),binclean)
+ifneq ($(MAKECMDGOALS),help)
+cmt_included = 1
+-include $(cmt_local_tagfile)
+endif
+endif
+
+else
+
+ifneq ($(MAKECMDGOALS),help)
+cmt_included = 1
+-include $(cmt_broadcast_tagfile)
+endif
+
+endif
+endif
+
+all ::
+ifndef CMTBCAST
+ifndef cmt_included
+	@$(MAKE) $(cmt_constituents_makefile)
+endif
+	$(MAKE) --no-print-directory -f $(cmt_constituents_makefile) $@
+else
+ifndef cmt_included
+	@$(MAKE) $(cmt_broadcast_makefile)
+endif
+	@$(MAKE) --no-print-directory -f $(cmt_broadcast_makefile) CMTBCAST= $@
+endif
+
+.DEFAULT :
+ifndef CMTBCAST
+ifndef cmt_included
+	@$(MAKE) $(cmt_constituents_makefile)
+endif
+	@$(MAKE) --no-print-directory -f $(cmt_constituents_makefile) $@
+else
+ifndef cmt_included
+	@$(MAKE) $(cmt_broadcast_makefile)
+endif
+	@$(MAKE) --no-print-directory -f $(cmt_broadcast_makefile) CMTBCAST= $@
+endif
 
 check_config ::
-	@$(cmtexe) check configuration; retval=$$?; \
-	if test $${retval} -ne 0; then \
-	  test -z "$(cmtmsg)" || \
-	  echo "$(CMTMSGPREFIX)" "(Makefile.header) Configuration error(s). Please correct" >&2; \
-	fi; exit $${retval}
-
-#	@$(cmtexe) check configuration; retval=$$?; \
-#	if test $${retval} = 0; then \
-#	  $(MAKE) --no-print-directory target="all" common_target; \
-#	else \
-#	  test -z "$(cmtmsg)" || \
-#	  echo "$(CMTMSGPREFIX)" "(Makefile.header) Configuration error(s). Please correct" >&2; \
-#	fi
-
-#no_check_config ::
-#	@$(MAKE) --no-print-directory target="all" common_target
-
-binclean ::
-	if test ! "$(bin)" = "./"; then \
-	  if test -d $(bin) ; then \
-	    test -z "$(cmtmsg)" || \
-	    echo "$(CMTMSGPREFIX)" "(Makefile.header) Removing binary directory $(bin)"; \
-	    \rm -rf $(bin) ; \
-	  fi ; \
-	fi
-
-#clean uninstall :: check_config
-#	@$(MAKE) --no-print-directory -f $(cmt_constituents_makefile) $@
-#	@$(cmtexe) check configuration
-#	@$(MAKE) --no-print-directory target="$@" common_target
-
-.DEFAULT ::
-	@$(MAKE) $(cmt_constituents_makefile)
-	@$(MAKE) --no-print-directory -f $(cmt_constituents_makefile) $@
-
-#	@$(cmtexe) check configuration
-#	@$(MAKE) --no-print-directory target="$@" common_target
-#	@$(MAKE) --no-print-directory target="config $@" common_target
-
-#
-#  Capture all possible targets
-#
-#common_target : $(cmt_constituents_makefile)
-#	@$(MAKE) --no-print-directory -f $(cmt_constituents_makefile) $(target)
-
-#$(cmt_constituents_makefile) : $(cmt_local_tagfile)
+	+@$(cmtexe) check configuration; retval=$$?; \
+	  if test $${retval} -ne 0; then \
+	    test -z "$(cmtmsg)" || \
+	    echo "$(CMTMSGPREFIX)" "(Makefile.header) Configuration error(s). Please correct" >&2; \
+	  fi; exit $${retval}
+
+$(cmt_check_configurationstamp) : $(use_requirements)
+	+@$(cmtexe) check configuration; retval=$$?; \
+	  if test $${retval} -ne 0; then \
+	    test -z "$(cmtmsg)" || \
+	    echo "$(CMTMSGPREFIX)" "(Makefile.header) Configuration error(s). Please correct" >&2; \
+	  fi; exit $${retval}
+	+$(silent) if test ! -d $(@D) ; then $(mkdir) -p $(@D); fi && \touch $@
+#	echo "$(CMTMSGPREFIX)" "(Makefile.header) Configuration error(s). Please correct" >&2; exit 17
 
 ifndef QUICK
-$(cmt_constituents_makefile) : check_config
-else
-$(cmt_constituents_makefile) :
-endif
-	$(echo) "(Makefile.header) Rebuilding $@"; \
+$(cmt_constituents_makefile) ::
+#$(cmt_constituents_makefile) : check_config
+else
+$(cmt_local_tagfile) $(cmt_constituents_makefile) : $(use_requirements)
+#$(cmt_local_tagfile) $(cmt_constituents_makefile) : $(cmt_check_configurationstamp)
+endif
+	+$(echo) "(Makefile.header) Rebuilding $@"; \
 	  if test ! -d $(@D) ; then $(mkdir) -p $(@D); fi; \
-	  $(cmtexe) -tag=$(tags) build constituents_config -out=$@; \
+	  $(cmtexe) -tag=$(tags) build constituents_config -out=$(cmt_constituents_makefile); \
 	  retval=$$?; \
 	  if test $${retval} -ne 0; then \
@@ -105,20 +113,20 @@
 
 ifndef QUICK
-$(cmt_local_tagfile) ::
-else
-$(cmt_local_tagfile) :
-endif
-	$(echo) "(Makefile.header) Rebuilding $@"; \
-	  if test -f $@; then rm -f $@; fi; \
-	  if test ! -d $(@D); then $(mkdir) -p $(@D); fi; \
-	  $(cmtexe) -tag=$(tags) build tag_makefile >$@
-	$(echo) "(Makefile.header) Rebuilding $(cmt_final_setup)"; \
-	  test ! -f $(cmt_local_setup) || \rm -f $(cmt_local_setup); \
-	  trap '\rm -f $(cmt_local_setup)' 0 1 2 15; \
-	  $(cmtexe) -tag=$(tags) show setup >$(cmt_local_setup) && \
-	  if [ -f $(cmt_final_setup) ] && \
-	    \cmp -s $(cmt_final_setup) $(cmt_local_setup); then \
-	    \rm $(cmt_local_setup); else \
-	    \mv -f $(cmt_local_setup) $(cmt_final_setup); fi
+$(cmt_broadcast_makefile) ::
+#$(cmt_broadcast_makefile) : check_config
+else
+$(cmt_broadcast_tagfile) $(cmt_broadcast_makefile) : $(use_requirements)
+#$(cmt_broadcast_makefile) : $(cmt_check_configurationstamp)
+endif
+	+$(echo) "(Makefile.header) Rebuilding $@"; \
+	  if test ! -d $(@D) ; then $(mkdir) -p $(@D); fi; \
+	  $(cmtexe) -tag=$(tags) build broadcast_config -out=$(cmt_broadcast_makefile); \
+	  retval=$$?; \
+	  if test $${retval} -ne 0; then \
+	    test -z "$(cmtmsg)" || \
+	    echo "$(CMTMSGPREFIX)" "(Makefile.header) Cannot generate $@" >&2; \
+	    \rm -f $@; \
+	  fi; \
+	  exit $${retval}
 
 #
@@ -134,8 +142,18 @@
 everywhere :: $(everywhere)
 
+ifndef CMTBCAST
+binclean ::
+	if _bin=`cd $(bin) 2>/dev/null&&pwd -P`&&_cur=`pwd -P`&&[ -n "$${_bin}" ]&&[ "$${_cur#$${_bin}}" = "$${_cur}" ] ; then \
+	    test -z "$(cmtmsg)" || \
+	    echo "$(CMTMSGPREFIX)" "(Makefile.header) Removing binary directory $(bin)"; \
+	    \rm -rf $(bin) ; \
+	fi
+endif
+
 #
 #   Display all targets
 #
 help ::
+ifndef CMTBCAST
 	@echo '--------------------------------------------------------------------------'
 	@echo 'You may select one of the following make targets :'
@@ -160,8 +178,82 @@
 	@echo '              run all applications defined with the -check option'
 	@echo ' '
-
-
-# explicit rule not to remake
+	@echo 'To switch to BCAST mode, set CMTBCAST to non-empty string.'
+else
+	@echo 'Targets for BCAST mode:'
+	@echo
+	@echo 'help        : this help'
+ifndef BCAST_ONLY
+ifndef BCAST_GLOBAL
+	@echo 'all         : (re)build all used packages in current project (this is default target)'
+else
+	@echo 'all         : (re)build all used packages in all projects (this is default target)'
+endif
+else
+	@echo 'all         : (re)build current package (this is default target)'
+endif
+	@echo 'clean       : remove everything that can be rebuilt'
+	@echo 'binclean    : fast erase of binary directories (and installation area)'
+	@echo 'uninstall   : remove everything installed in the installation area'
+	@echo
+ifndef BCAST_GLOBAL
+	@uses=`$(cmtexe) -private show macros '_project$$|package$$' -tag=$(tags)| \
+	  awk -F = '{if ($$1 ~ /_project$$/) {uses[substr($$1,1,length($$1)-8)]=$$2}else if ($$1 == "package") {cur = $$2;gsub("'\''","",cur)}}END{for (u in uses){if (uses[u]==uses[cur]) print u}}'`; \
+	  for u in $${uses}; do \
+	    echo "$${u} : (re)build package $${u} ($(_groups))"; \
+	    echo "$${u}clean : remove everything that can be rebuilt in package $${u}"; \
+	    echo "$${u}binclean : fast erase of binary directory in package $${u}"; \
+	    echo "$${u}uninstall : remove everything installed in the installation area from package $${u}"; \
+	  done
+else
+	@uses=`$(cmtexe) -private show macros '_root$$' -tag=$(tags)| \
+	  awk -F = '{u=substr($$1,1,length($$1)-5);if (u != "CMT" && u != "CMTHOME" && u != "CMTUSERCONTEXT") print u}'`; \
+	  for u in $${uses}; do \
+	    echo "$${u} : (re)build package $${u} ($(_groups))"; \
+	    echo "$${u}clean : remove everything that can be rebuilt in package $${u}"; \
+	    echo "$${u}binclean : fast erase of binary directory in package $${u}"; \
+	    echo "$${u}uninstall : remove everything installed in the installation area from package $${u}"; \
+	  done
+endif
+	@echo
+ifndef BCAST_ONLY
+	@echo '   ... with dependencies packages (may be ignored by setting BCAST_ONLY).'
+else
+	@echo '   ... without dependencies packages (may be included by unsetting BCAST_ONLY).'
+endif
+	@echo
+ifndef BCAST_GLOBAL
+	@echo 'To (re)build packages in all projects, set BCAST_GLOBAL.'
+else
+	@echo 'To (re)build packages in current project, unset BCAST_GLOBAL.'
+endif
+ifndef NO_ALL_GROUPS
+	@echo 'To (re)build default group only, set NO_ALL_GROUPS.'
+ifndef CMTACTIONS
+	@echo 'To also (re)build cmt_actions group, set CMTACTIONS.'
+endif
+else
+	@echo 'To (re)build all groups, unset NO_ALL_GROUPS.'
+endif
+	@echo
+	@echo 'To switch to PACKAGE mode, unset CMTBCAST.'
+endif
+
+ifndef NO_ALL_GROUPS
+ifndef CMTACTIONS
+_groups = all groups except cmt_actions
+else
+_groups = all groups
+endif
+else
+_groups = default group
+endif
+
+# explicit rule to avoid implicit rule search
+# and not to remake
 ${CMTROOT}/src/Makefile.header : ;
+${CMTROOT}/src/Makefile.core : ;
+ifdef use_requirements
+$(use_requirements) : ;
+endif
 
 # for multiple command line goals,
Index: CMT/HEAD/src/setup.csh
===================================================================
--- CMT/HEAD/src/setup.csh	(revision 586)
+++ CMT/HEAD/src/setup.csh	(revision 588)
@@ -54,2 +54,12 @@
 
 alias jcmt '(java cmt_parser)'
+
+# Set MAKEFLAGS, if unset (similar to NPROC with Plan 9 mk utility)
+if ( $?MAKEFLAGS == 0 ) then
+  setenv MAKEFLAGS -j`getconf _NPROCESSORS_ONLN` || unsetenv MAKEFLAGS
+  if ( $?MAKEFLAGS == 1 ) then
+    setenv MAKEFLAGS "${MAKEFLAGS} QUICK=1"
+  else
+    setenv MAKEFLAGS "QUICK=1"
+  endif
+endif
Index: CMT/HEAD/src/setup.sh
===================================================================
--- CMT/HEAD/src/setup.sh	(revision 586)
+++ CMT/HEAD/src/setup.sh	(revision 588)
@@ -11,5 +11,5 @@
 fi
 
-if [ `expr $- : '.*i'` -ne 0 ]; then
+if [ -n "$-" ] && [ "${-#*i}" != "$-" ]; then
 if [ -n "${ZSH_NAME-}" ]; then
   . ${CMTROOT}/src/setup.zsh
@@ -47,2 +47,13 @@
 
 alias jcmt='(java cmt_parser)'; export jcmt
+
+# Set MAKEFLAGS, if unset (similar to NPROC with Plan 9 mk utility)
+if [ -z ${MAKEFLAGS+CMT} ]; then
+  MAKEFLAGS=-j`getconf _NPROCESSORS_ONLN 2>/dev/null` && export MAKEFLAGS || unset MAKEFLAGS
+  if [ -n "${MAKEFLAGS:-}" ]; then
+    MAKEFLAGS="${MAKEFLAGS} QUICK=1"
+  else
+    MAKEFLAGS="QUICK=1"
+  fi
+  export MAKEFLAGS
+fi
